"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Step(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "date",
        "status",
        "stepName",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import metrics as metrics_1_2_2

        return {
            "status": metrics_1_2_2.StepStatus,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import metrics as metrics_1_2_2

        return {
            "org.gel.models.metrics.avro.StepStatus": metrics_1_2_2.StepStatus,
            "org.gel.models.metrics.avro.Step": metrics_1_2_2.Step,
        }

    __slots__ = [
        "date",
        "status",
        "stepName",
    ]

    def __init__(
        self,
        date,
        status,
        stepName,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.Step model.

        :param date:
        :type date: str
        :param status:
        :type status: StepStatus
        :param stepName:
        :type stepName: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
